<?php
/**
 * Copyright 2010-2013 Amazon.com, Inc. or its affiliates. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 *
 * http://aws.amazon.com/apache2.0
 *
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

namespace BackupGuard\Aws\Common\Exception;

use BackupGuard\Guzzle\Http\Message\RequestInterface;
use BackupGuard\Guzzle\Http\Message\Response;

/**
 * Interface used to create AWS exception
 */
interface ExceptionFactoryInterface
{
    /**
     * Returns an AWS service specific exception
     *
     * @param RequestInterface $request  Unsuccessful request
     * @param Response         $response Unsuccessful response that was encountered
     *
     * @return \Exception|AwsExceptionInterface
     */
    public function fromResponse(RequestInterface $request, Response $response);
}
